#         Script : CuteTopics v1.00 by David Proper (Dr. Nibble [DrN])
#                  Copyright 2001 Radical Computer Systems
#                             All Rights Reserved
#
#       Testing
#      Platforms : Linux 2.2.16   TCL v8.3
#                  Eggdrop v1.6.2
#            And : SunOS 5.8      TCL v8.3
#                  Eggdrop v1.5.4
#
#    Description : CuteTopics is a lame little TCL that will let you set
#                  a channel topic with "topic frames". You can store,
#                  list, and delete the frames.
#                  Included data file has 50 topic frames
#
#        History :   /  /2001 - First Release
#
#
#   Future Plans : o Fix Bugs. :)
#                  o Add in more topic alteration commands
#
# Author Contact :     Email - DAProper@earthlink.net
#                  Home Page - http://home.earthlink.net/~daproper
#                        IRC - Nick: DrN  UnderNet/DALnet
#          Support Channels  - #RCS @ UnderNet
#                              #RCS @ DALnet
#
# Chaotix.Net is currentlly offline. Should return no later then Jan 1st, 2002
#
#   Radical Computer Systems - http://www.chaotix.net/rcs/
# To subscribe to the RCS mailing list: mail majordomo@chaotix.net and in
#  BODY of message, type  subscribe rcs-list
#
#  Feel free to Email me any suggestions/bug reports/etc.
# 
# You are free to use this TCL/script as long as:
#  1) You don't remove or change author credit
#  2) You don't release it in modified form. (Only the original)
# 
# If you have a "too cool" modification, send it to me and it'll be
# included in the official release. (With your credit)
#
# Commands Added:
#  Where     F CMD          F CMD            F CMD           F CMD
#  -------   - ----------   - ------------   - -----------   - ----------
#  Public:   N/A
#     MSG:   N/A
#     DCC:   N/A
#
# Public Matching: N/A
#

#\
# |##### NOTE: Anything on the Chaotix.Net domain is currently offline
# |#####       until we move.
#/

set cmdchar_ "!"

proc cmdchar { } {
global cmdchar_
return $cmdchar_
}

set cutetopic(datafile) "~/cutetopic.dat"
set cutetopic(ver) "v1.00.00"

bind dcc o ct dcc_ct
proc dcc_ct {hand idx args} {
 set chan [lindex [console $idx] 0]
 putidx $idx "Channel set to: $chan"
 pub_cutetopic $idx *!*@* $hand $chan "[lindex $args 0]"
}

bind pub - [cmdchar]ct pub_cutetopic
proc pub_cutetopic {nick uhost hand chan line} {
# putlog "$nick $uhost $hand $chan $line"
 subst -nobackslashes -nocommands -novariables line

#                    regsub -all {\"} $line \\" line
#                    regsub -all {\.} $line \\. line
#                    regsub -all {\;} $line \\; line
                    regsub -all {\\} $line !SL! line
                    regsub -all {\<} $line !LT! line
                    regsub -all {\>} $line !GT! line
                    regsub -all {\"} $line !QT! line
                    regsub -all {\(} $line !LP! line
                    regsub -all {\)} $line !RP! line
                    regsub -all {\{} $line !LB! line
                    regsub -all {\}} $line !RB! line
                    regsub -all {\[} $line !LF! line
                    regsub -all {\]} $line !RF! line
                    regsub -all {\;} $line !QL! line
                    regsub -all {\:} $line !CO! line
                    regsub -all {\.} $line !PD! line
 set rest $line
 set cmd [string tolower [lindex $rest 0]]
 set rest [lrange $rest 1 end]
 if {$cmd == ""} {set cmd "help"}
 switch $cmd {
  "list" {list_cutetopic $nick $uhost $hand $chan $rest}
   "set" {set_cutetopic $nick $uhost $hand $chan $rest}
   "add" {add_cutetopic $nick $uhost $hand $chan $rest}
   "del" {del_cutetopic $nick $uhost $hand $chan $rest}
  "help" { cuteout $nick "Calling Syntax:"
          cuteout $nick " [cmdchar]ct list          - Lists CuteTopics"
          cuteout $nick " [cmdchar]ct set # topic   - Sets topic using CuteTopic"
          cuteout $nick " [cmdchar]ct add template  - Adds template to CuteTopics"
          cuteout $nick "  Use &text for the topic and &chan for the channel name in the template."
          cuteout $nick " [cmdchar]ct del #         - Deletes CuteTopic from database"
         }
             }
}

proc del_cutetopic {nick uhost hand chan rest} {
global cutetopic cutetopiclist
 if {$rest == ""} {cuteout $nick "Calling Syntax: [cmdchar]ct del #";return 0}
 set num [lindex $rest 0]
 set data $cutetopiclist($num)
 if {($num < 0) && ($num > $cutetopic(tot))} {cuteout $nick "ERROR: Invalid number. Must be in the range of 1-$cutetopic(tot)"; return 0}
 for {set rloop $num} {$rloop < [expr $cutetopic(tot)]} {incr rloop} {
  set rloop1 [expr $rloop + 1]
#  putlog "Copying #$rloop1 to #$rloop"
  set cutetopiclist($rloop) $cutetopiclist($rloop1)
  }
 set cutetopic(tot) [expr $cutetopic(tot) - 1]
 regsub -all {!PD!} $data \. data; regsub -all {!CO!} $data \: data
 regsub -all {!SQ!} $data \' data; regsub -all {!QL!} $data \; data
 regsub -all {!QT!} $data \" data; regsub -all {!LT!} $data \< data
 regsub -all {!GT!} $data \> data; regsub -all {!LP!} $data \( data
 regsub -all {!RP!} $data \) data; regsub -all {!LB!} $data \{ data
 regsub -all {!RB!} $data \} data; regsub -all {!LF!} $data \[ data
 regsub -all {!RF!} $data \] data; regsub -all {!SL!} $data \\ data
 cuteout $nick "Deleted CuteTopic #$num: $data"
 save_cutetopic
}

proc set_cutetopic {nick uhost hand chan rest} {
global cutetopic cutetopiclist
 #  if {[botisop $channel] == 0}
 set num [lindex $rest 0]
 set rest [lrange $rest 1 end]
 if {$rest == ""} {cuteout $nick "Calling Syntax: [cmdchar]ct set # topic";return 0}
 if {($num < 0) && ($num > $cutetopic(tot))} {cuteout $nick "ERROR: Invalid number. Must be in the range of 1-$cutetopic(tot)"; return 0}
 set data $cutetopiclist($num)
 regsub -all {&text} $data $rest data
 regsub -all {&chan} $data $chan data
 regsub -all {!PD!} $data \. data; regsub -all {!CO!} $data \: data
 regsub -all {!SQ!} $data \' data; regsub -all {!QL!} $data \; data
 regsub -all {!QT!} $data \" data; regsub -all {!LT!} $data \< data
 regsub -all {!GT!} $data \> data; regsub -all {!LP!} $data \( data
 regsub -all {!RP!} $data \) data; regsub -all {!LB!} $data \{ data
 regsub -all {!RB!} $data \} data; regsub -all {!LF!} $data \[ data
 regsub -all {!RF!} $data \] data; regsub -all {!SL!} $data \\ data
 putserv "TOPIC $chan :$data"
}

proc add_cutetopic {nick uhost hand chan line} {
global cutetopic cutetopiclist
# putlog "line:$line"
# set rest [lindex $line 0]
 regsub -all {\^C} $line \003 line
 regsub -all {\^B} $line \002 line
 regsub -all {\^_} $line \026 line
 set cutetopic(tot) [expr $cutetopic(tot) + 1]
 set cutetopiclist($cutetopic(tot)) "$line"
 set data $line
 regsub -all {!PD!} $data \. data; regsub -all {!CO!} $data \: data
 regsub -all {!SQ!} $data \' data; regsub -all {!QL!} $data \; data
 regsub -all {!QT!} $data \" data; regsub -all {!LT!} $data \< data
 regsub -all {!GT!} $data \> data; regsub -all {!LP!} $data \( data
 regsub -all {!RP!} $data \) data; regsub -all {!LB!} $data \{ data
 regsub -all {!RB!} $data \} data; regsub -all {!LF!} $data \[ data
 regsub -all {!RF!} $data \] data; regsub -all {!SL!} $data \\ data

 cuteout $nick "Added CuteTopic #$cutetopic(tot): $data"
 save_cutetopic
}

proc cuteout {nick channel text} {

}

proc list_cutetopic {nick uhost hand chan rest} {
global cutetopic cutetopiclist
if {$cutetopic(tot) == 0} {cuteout $nick "There are no CuteTopics."; return 0}
 cuteout $nick "Listing $cutetopic(tot) CuteTopics"
 for {set rloop 1} {$rloop < [expr $cutetopic(tot) + 1]} {incr rloop} {
  set data $cutetopiclist($rloop)
  regsub -all {!PD!} $data \. data; regsub -all {!CO!} $data \: data
  regsub -all {!SQ!} $data \' data; regsub -all {!QL!} $data \; data
  regsub -all {!QT!} $data \" data; regsub -all {!LT!} $data \< data
  regsub -all {!GT!} $data \> data; regsub -all {!LP!} $data \( data
  regsub -all {!RP!} $data \) data; regsub -all {!LB!} $data \{ data
  regsub -all {!RB!} $data \} data; regsub -all {!LF!} $data \[ data
  regsub -all {!RF!} $data \] data; regsub -all {!SL!} $data \\ data

  cuteout $nick "[format "%3s" $rloop]: $data"
  }
}

set cutetopic(tot) 0
proc load_cutetopic {} {
global cutetopic cutetopiclist
  if {[file exists $cutetopic(datafile)]} {
                                 set in [open $cutetopic(datafile) r]
                                 set cutetopic(tot) 0
                                 while {![eof $in]} {
                                  set data [gets $in]
                                  if {$data != ""} {
                                   set cutetopic(tot) [expr $cutetopic(tot) + 1]
                                   set cutetopiclist($cutetopic(tot)) $data
                                                   }
                                                    }
                                 close $in
                                 putlog "Loaded $cutetopic(tot) CuteTopic entries"
                                } {
                                   set cutetopic(tot) 0
                                   if {[info exists cutetopiclist]} {unset cutetopiclist}

                                  }
                    }
load_cutetopic


proc save_cutetopic {} {
global cutetopic cutetopiclist
 putlog "Saving CuteTopic $cutetopic(ver) Data to $cutetopic(datafile)"
 set out [open $cutetopic(datafile) w]
 for {set rloop 1} {$rloop < [expr $cutetopic(tot) + 1]} {incr rloop} {
  puts $out $cutetopiclist($rloop)
                                                                }
 close $out
}

proc cuteout {nick text} {
 if {[isnum $nick]} {putidx $nick "$text"} {putnotc $nick "$text"}
}

# isnumber taken from alltools.tcl
proc isnum {string} {
  if {([string compare $string ""]) && (![regexp \[^0-9\] $string])} then {
    return 1
  }
  return 0
}

putlog "CuteTopics $cutetopic(ver) by David Proper (DrN) -: LoadeD :-"
return "CuteTopics $cutetopic(ver) by David Proper (DrN) -: LoadeD :-"

